#ifndef ASK_H
#define ASK_H

#include <SDL.h>

#define LOOP_CONT		0
#define LOOP_RESTART		1
#define LOOP_QUIT		2
#define LOOP_REDRAW_ACTIVE	3

enum menu_ids {
    menu_nothing = 0,
    menu_new_game,
    menu_options,
    menu_quit,
    menu_players,
    menu_screen_size,
    menu_fullscreen,
    menu_controls,
    menu_return,
    menu_contr_player_1 = 32,
    menu_contr_player_2,
    menu_contr_player_3,
    menu_contr_player_4,
    menu_contr_player_5,
    menu_contr_player_6,
    menu_contr_player_7,
    menu_contr_player_8,
    menu_contr_player_1_method = 40,
    menu_contr_player_1_up,
    menu_contr_player_1_down,
    menu_contr_player_1_left,
    menu_contr_player_1_right,
    menu_contr_player_1_blast,
    menu_contr_player_1_shot,
    menu_contr_player_1_joystick,
    menu_contr_player_1_shot_button,
    menu_contr_player_1_blast_button,
    menu_contr_player_1_joy_cal,
    menu_contr_player_2_method = 52,
    menu_contr_player_2_up,
    menu_contr_player_2_down,
    menu_contr_player_2_left,
    menu_contr_player_2_right,
    menu_contr_player_2_blast,
    menu_contr_player_2_shot,
    menu_contr_player_2_joystick,
    menu_contr_player_2_shot_button,
    menu_contr_player_2_blast_button,
    menu_contr_player_2_joy_cal,
    menu_contr_player_3_method = 64,
    menu_contr_player_4_method = 76,
    menu_contr_player_5_method = 88,
    menu_contr_player_6_method = 100,
    menu_contr_player_7_method = 112,
    menu_contr_player_8_method = 124
};

typedef struct menu_item_struct {
    SDL_Rect item_rect;
    SDL_Surface *normal, *active;
    enum menu_ids action_id;
} menu_item_type;

void init_menu();
void free_menu();
void draw_menu_item(SDL_Surface *to, const int item_no, const int selected);
void clean_menu_item(SDL_Surface *to, const int item_no);
void draw_menu(SDL_Surface *to);
menu_item_type *create_menu(const char *menu_str[], const enum menu_ids ids_for_menu_items[]);
void delete_menu(menu_item_type *menu_to_delete);
int start_menu(SDL_Surface *to);
int action_handler(SDL_Surface **to, const enum menu_ids action_id, const Uint8 button);
void draw_text_centered(SDL_Surface *to, const char *text, const int ptsize, const Uint16 y_pos, const SDL_Color fg, const SDL_Color bg, SDL_Rect *clean_rect);

#endif /* ASK_H */
