#ifndef COMMON_H
#define COMMON_H

#include <SDL/SDL.h>

#ifdef SDL_ALPHA_TRANSPARENT
#   define SET_0_TRANSPARENT_100_OPAQUE(value)		((value * 255) / 100)
#else /* !SDL_ALPHA_TRANSPARENT */
#   define SDL_ALPHA_TRANSPARENT			255
#   define SDL_ALPHA_OPAQUE				0
#   define SET_0_TRANSPARENT_100_OPAQUE(value)		(255 - ((value * 255) / 100))
#endif /* !SDL_ALPHA_TRANSPARENT */

#define IMAGE_SUFFIXES_COUNT		3
#define MAX_FILE_NAME_LENGHT		255
#define MAX_RELATIVE_PATH_LENGHT	80

typedef enum {
    other_file,
    config_file,
    image_file,
    font_file
} file_type;

typedef struct suffix_struct {
    char *suffix_str;
    Uint8 transparent_support;
} suffix_type;

typedef char suffix_str_array_type[IMAGE_SUFFIXES_COUNT][MAX_RELATIVE_PATH_LENGHT + 1];

extern const suffix_type suffixes[IMAGE_SUFFIXES_COUNT];

SDL_Surface *try_load_image(const char *filename_part, const int ship_number, const Uint8 transparent);
suffix_str_array_type *try_subst_suffixes(const char *fmt, const int ship_number);
char *get_file(const char *filename, const file_type file);

void draw_line(SDL_Surface *to, const Uint16 x1, const Uint16 y1, const Uint16 x2, const Uint16 y2, const SDL_Color *color);
void draw_rect(SDL_Surface *to, const SDL_Rect *rect, const SDL_Color *color);
void draw_cross(SDL_Surface *to, const Uint16 x, const Uint16 y, const Uint16 size, const SDL_Color *color);
void draw_gauge(SDL_Surface *to, const SDL_Rect *rect, const float percent);

#endif /* COMMON_H */
