#include "config.h"
#include <SDL/SDL.h>
#include "background.h"
#include "common.h"
#include "gauges.h"
#include "options.h"
#include "ship.h"
#include "main.h"

#define GAUGES_COUNT	4

const Uint16 gauge_x_size = 100, gauge_y_size = 7;
const Sint16 gauge_positions[GAUGES_COUNT][2] = {
    { 10, 10 },
    {-10, 10 },
    { 10,-10 },
    {-10,-10 }
};

void
prepare_draw_gauges(SDL_Surface *to)
{
    int counter, counter2;
    SDL_Rect rect;

    rect.w = gauge_x_size;
    rect.h = gauge_y_size;
    for (counter = 0; counter < GAUGES_COUNT; counter++)
	if (is_created_ship(counter)) {
	    if (gauge_positions[counter][0] < 0)
		rect.x = screen_width - gauge_x_size + gauge_positions[counter][0];
	    else
		rect.x = gauge_positions[counter][0];
	    if (gauge_positions[counter][1] < 0)
		rect.y = screen_height - gauge_y_size + gauge_positions[counter][1];
	    else
		rect.y = gauge_positions[counter][1];
	    draw_background(to, &rect);
	    for (counter2 = 0; counter2 < maximum_ships_count; counter2++)
		if (is_created_ship(counter2))
		    redraw_ship_if_hit(counter2, &rect);
	}
}

void
draw_all_gauges(SDL_Surface *to)
{
    int counter;
    SDL_Rect rect;

    rect.w = gauge_x_size;
    rect.h = gauge_y_size;
    for (counter = 0; counter < GAUGES_COUNT; counter++)
	if (is_created_ship(counter)) {
	    if (gauge_positions[counter][0] < 0)
		rect.x = screen_width - gauge_x_size + gauge_positions[counter][0];
	    else
		rect.x = gauge_positions[counter][0];
	    if (gauge_positions[counter][1] < 0)
		rect.y = screen_height - gauge_y_size + gauge_positions[counter][1];
	    else
		rect.y = gauge_positions[counter][1];
	    draw_gauge(to, &rect, get_ship_health(counter));
	}
}

void
update_all_gauges(SDL_Surface *to)
{
    int counter;
    SDL_Rect rect;

    rect.w = gauge_x_size;
    rect.h = gauge_y_size;
    for (counter = 0; counter < GAUGES_COUNT; counter++)
	if (is_created_ship(counter)) {
	    if (gauge_positions[counter][0] < 0)
		rect.x = screen_width - gauge_x_size + gauge_positions[counter][0];
	    else
		rect.x = gauge_positions[counter][0];
	    if (gauge_positions[counter][1] < 0)
		rect.y = screen_height - gauge_y_size + gauge_positions[counter][1];
	    else
		rect.y = gauge_positions[counter][1];
	    SDL_UpdateRects(to, 1, &rect);
	}
}
