#ifndef MAP_H
#define MAP_H	1

#include <SDL/SDL.h>
#include "list.h"

typedef struct {
    Sint16 x_cur, x_stop, y_start, y_cur, y_stop;
    struct node_type *node_ptr;
} map_walk_type;

void init_map();
void free_map();
void reinit_map();
void clean_map();
void insert_object_into_map(const SDL_Rect *position, object_type *object);
void delete_object_from_map(const SDL_Rect *position, object_type *object);
void move_with_object_in_map(const SDL_Rect *old_position, const SDL_Rect *new_position, object_type *object);
object_type *get_first_object_from_map(const SDL_Rect *position, map_walk_type *walk_ptr);
object_type *get_next_object_from_map(map_walk_type *walk_ptr);
int get_hash(const Uint16 x, const Uint16 y);

#endif /* MAP_H */
