#ifndef SHOT_H
#define SHOT_H

#include "objects.h"
#include "ship.h"

typedef enum {
    normal_shot,
    blast_shot
} shot_strength_type;

void init_shots_array(void);
void free_shots_array(void);
object_type *create_and_init_shot(object_type *owner, const shot_strength_type type);
void draw_shot(const int shot_number, SDL_Surface *to);
void update_shot(const int shot_number, SDL_Surface *to);
void clean_shot(const int shot_number, SDL_Surface *to);
void purge_shot(const int shot_number, SDL_Surface *to);
void delete_dead_shots(SDL_Surface *to);
void update_all_shots(SDL_Surface *to);

void do_move_with_all_shots(SDL_Surface *to);
void do_move_with_shot(const int shot_number, SDL_Surface *to);
void delete_all_shots(void);

/* Internal functions */
int check_hit(const int shot_number);
/*void MoveShot(const int shot_number, const Sint16 delta_left, const Sint16 delta_top, SDL_Surface *to);*/

#endif /* SHOT_H */
